#!/bin/bash

#_____________________________________________________________________
# $Date: 2012/08/02 06:08:40 $
# By UDA'Software 2011

#_____________________________________________________________________
# SETUP
#
wget_timeout=16
twitter_check=1800
max_tweets=32

script_path=$(dirname $0)
config_file="${script_path}/twitter.cfg"

#_____________________________________________________________________
function print_tweet() {
    if [ ${flag_bot} == 0 ]; then
	printf '/budus if $nickname.away = 0 /%s %s [%%B%s%%O] %s\n' "${command}" "${parameter:-/ECHO}${sub_command}" "${account}" "${tweet_record/_BUDUSCRIPT_BOLD_/%%B}" | sed 's@&quot;@"@g' | "${filter:-cat}"
	[ ${flag_skip_store_sendend:-0} == 0 ] && printf '/budus if $nickname.away = 0 /budus pipe_script_silent echo \(%s\) >> \(%s\)\n' "${tweet_record/*>/}" "${dat_file_path}${account}.dat"
	[ ${BUDUSCRIPT_TWITTER_DEBUG:-0} != 0 ] && printf '%s> TWEET [%s]: echo "%s" >> '\''%s'\''\n' "$(date +%H:%M:%S)" "${account}" "${tweet_record/*>/}" "${dat_file_path}${account}.dat" >&2
    else
	if [ "$(echo "${script_path}" | grep -F '.xchat/')" != "" ]; then
	    printf '/%s %s [%%B%s%%O] %s\n' "${command}" "${parameter:-/ECHO}${sub_command}" "${account}" "${tweet_record/_BUDUSCRIPT_BOLD_/%B}" | sed 's@&quot;@"@g' | "${filter:-cat}"
	else
	    printf '/%s %s [%%B%s%%O] %s\n' "${command}" "${parameter:-/ECHO}${sub_command}" "${account}" "${tweet_record/_BUDUSCRIPT_BOLD_/%%B}" | "${filter:-cat}"
	fi
	
	[ ${flag_skip_store_sendend:-0} == 0 ] && printf '/budus pipe_script_silent echo \(%s\) >> \(%s\)\n' "${tweet_record/*>/}" "${dat_file_path}${account}.dat"
    fi
}

#_____________________________________________________________________
# Messaggio per il terminale di debug (non modificare se non
# strettamente necessario).
echo "$(date +%H:%M:%S)> ${0} ${*}" >&2

#_____________________________________________________________________
# Gestione dei parametri dello script
if [ "${1}" == "BOT" ]; then
    flag_bot=1
    config_file="${script_path}/twitter_bot.cfg"
    dat_file_path="${HOME}/tmp/buduscript_twitter_BOT__"
else
    flag_bot=0
    dat_file_path="${HOME}/tmp/buduscript_twitter__"
fi

if [ "${1}" == "ENABLE" ]; then
    if [ -f "${config_file}.lock" ]; then
	mv -f "${config_file}.lock" "${config_file}"
	printf '/ECHO %%B[TWITTER]%%O\t%%C8,1%%B ATTENZIONE:%%O%%C8,1 Disabilitazione abortita; TWITTER abilitato.\n'
    elif [ -f "${config_file}.deactivated" ]; then
	mv -f "${config_file}.deactivated" "${config_file}"
	printf '/ECHO %%B[TWITTER]%%O\t%%C7,1%%B AVVERTIMENTO:%%O%%C7,1 TWITTER abilitato.\n'
    else
	printf '/ECHO %%B[TWITTER]%%O\t%%C8,1%%B ATTENZIONE:%%O%%C8,1 TWITTER gi abilitato.\n'
	printf '/budus DeleteCommandInQueue(0) %s\n' "${0}"
	printf '/budus InsertCommandInQueueTimed(0) %d /budus pipe_script_silent %s\n' "60" "${0}"
	exit 0;
    fi
fi

if [ "${1}" == "DISABLE" ]; then
    if [ ! -f "${config_file}.lock" ]; then
	mv -f "${config_file}" "${config_file}.lock"
	printf '/ECHO %%B[TWITTER]%%O\t%%C7,1%%B AVVERTIMENTO:%%O%%C7,1 TWITTER disabilitazione in corso.\n'
    else
	printf '/ECHO %%B[TWITTER]%%O\t%%C4,1%%B ERRORE:%%O%%C4,1 Disattivazione gi avviata.\n'
	exit 1;
    fi
    
    exit 0;
fi

if [ "${1}" == "LIST" ]; then
    printf '/ECHO %%B[TWITTER]%%O\t%%C7,1%%B Elenco dei Tweets nel database:\n'
    
    IFS=$'\n'
    for record in $(cat "${config_file}" | grep -v '^#' | grep '^[a-zA-Z0-9_]* [a-zA-Z0-9]*'); do
	account=$(echo "${record}" | awk -F' ' '{print $1}')
	command=$(echo "${record}" | awk -F' ' '{print $2}' \
	    | sed 's@[Ss][Ee][Nn][Dd]@budus sendsess@' \
	    | sed 's@[Ee][Cc][Hh][Oo]@budus sendsess $current_tab@')
	parameter=$(echo "${record}" | awk -F' ' '{print $3}')
	[ "${parameter}" != "" ] && sub_command=" /SAY "
	filter=$(echo "${record}" | awk -F' ' '{print $4}')
	
	echo "$(date +%H:%M:%S)> TWEET [${account}]: ${command} - ${parameter}" >&2
	
	flag_skip_store_sendend=1
	if [ -f "${dat_file_path}${account}.db" ]; then
	    for tweet_record in $(cat "${dat_file_path}${account}.db"); do
		print_tweet
	    done
	else
	    printf '/ECHO %%B[TWITTER]%%O\t%%C8,1%%B ATTENZIONE:%%O%%C8,1 Per l'\''account %s non  disponibile un database; se Twitter  attivo, sar aggiornato prossimamente.\n' "${account}"
	fi
    done
    
    exit 0;
fi

if [ -f "${config_file}.lock" ]; then
    mv -f "${config_file}.lock" "${config_file}.deactivated"
    printf '/ECHO %%B[TWITTER]%%O\t%%C7,1%%B AVVERTIMENTO:%%O%%C7,1 TWITTER disattivato.\n'
fi

#_____________________________________________________________________
[ -f "${config_file}.deactivated" ] && exit 0;

if [ ! -f "${config_file}" ]; then
    if [ -f "${script_path}/budus_first" ]; then
	printf '/ECHO %%B[TWITTER]%%O\t%%C4,1%%B AVVERTIMENTO:%%O%%C8,1 Il file di configurazione%%B %s%%O%%C4,1 non  ancora stato creato dalla procedura di installazione;  necessario ri-avviare XChat per completare l'\''installazione.\n' "${config_file}"
    else
	printf '/ECHO %%B[TWITTER]%%O\t%%C4,1%%B ERRORE:%%O%%C4,1 Il file di configurazione%%B %s%%O%%C4,1 non  stato trovato. Consultare la FAQ di BuDuScRiPt per ulteriori informazioni.\n' "${config_file}"
    fi
    
    exit 1;
fi

#_____________________________________________________________________
# Ricerca della directory temporanea; se si necessita di creare dei
# files temporanei, sarebbe opportuno collocarli in ${HOME}/tmp.
if [ ! -d ${HOME}/tmp ]; then
    printf '/ECHO %%B[TWITTER]%%O\t%%C4,1%%B ERRORE:%%O%%C4,1 Directory%%B %s%%O%%C4,1 non trovata. Crearla con il comando:%%O /EXEC mkdir %s\n' "${HOME}/tmp" "${HOME}/tmp"
    printf '/ECHO %%B[TWITTER]%%O\t%%C4,1%%B        %%O%%C7,1Il servizio sar operativo dopo la creazione di suddetta cartella, al prossimo avvio di XChat.\n'
    printf '/budus InsertInBuffer() /EXEC mkdir %s\n' "${HOME}/tmp"
    
    exit 1;
fi

IFS=$'\n'
for record in $(cat "${config_file}" | grep -v '^#' | grep '^[a-zA-Z0-9_]* [a-zA-Z0-9]*'); do
    account=$(echo "${record}" | awk -F' ' '{print $1}')
    command=$(echo "${record}" | awk -F' ' '{print $2}' | sed 's@[Ss][Ee][Nn][Dd]@budus sendsess@' | sed 's@[Ee][Cc][Hh][Oo]@budus sendsess $current_tab@')
    parameter=$(echo "${record}" | awk -F' ' '{print $3}')
    [ "${parameter}" != "" ] && sub_command=" /SAY "
    filter=$(echo "${record}" | awk -F' ' '{print $4}')
    if [ "${filter}" != "" ] && [ ! -f "${filter}" ]; then
	printf '/ECHO %%C4,0%%BERRORE: Il filtro ( %s ) non risulta presente. Verificare il percorso.\n' "${filter}"
    fi
    
    echo "$(date +%H:%M:%S)> TWEET [${account}]: ${command} - ${parameter}" >&2
    
    {
	wget -q -t 8 -O - -T ${wget_timeout} "http://search.twitter.com/search.json?q=from:${account}" \
	    > "${dat_file_path}${account}.source"
	
	[ -f "${dat_file_path}${account}.source" ] && \
	    twitter_db=$(cat "${dat_file_path}${account}.source" \
	    | sed 's@:\[{@\n@g' \
	    | sed 's@"created_at":@\n"created_at":@g' \
	    | grep -F '"created_at":' \
	    | sed 's@"[a-z_]*":@\n&1@g' \
	    | grep -iF -e '"created_at":' -e '"text":' \
	    | tr '\n' ' ' \
	    | sed 's@"[Cc][Rr][Ee][Aa][Tt][Ee][Dd]_[Aa][Tt]":\([0-9]*\)\?@\n@g' \
	    | sed 's@"[Tt][Ee][Xx][Tt]":\([0-9]*\)\?@@' \
	    | sed 's@^"@@' \
	    | sed 's@", "@\t@' \
	    | sed 's@", $@@' \
	    | sed 's@%@%%@g' \
	    | sed 's@&lt;@<@g' \
	    | sed 's@&gt;@>@g' \
	    | sed 's@\\\/@/@g' \
	    | grep -v '^$' \
	    | awk -F'\t' '{print "TWEET: ["$1"] > _BUDUSCRIPT_BOLD_"$2}')
	
	IFS=$'\n'
	for tweet_record in ${twitter_db}; do
	    [ ${BUDUSCRIPT_TWITTER_DEBUG:-0} != 0 ] && /usr/bin/printf "${tweet_record}\n" >&2
	    /usr/bin/printf "${tweet_record}\n"
	done
    } > "${dat_file_path}${account}.db"
    
    if [ ! -f "${dat_file_path}${account}.db" ] || \
	[ $(wc -l "${dat_file_path}${account}.db" | cut -f1 -d' ') == 0 ]; then
	if [ ! -f "${dat_file_path}${account}.lock" ]; then
	    touch "${dat_file_path}${account}.lock"
	elif [ $(cat "${dat_file_path}${account}.lock" | wc -l) -gt 16 ] && \
	    [ $(cat "${dat_file_path}${account}.lock" | wc -l) -lt 24 ]; then
	    printf '/ECHO %%B[TWITTER]%%O\t%%C4,1%%B ERRORE:%%O%%C4,1 Il database relativo all'\''account %s risulta nullo; se il problema persiste, disabilitare il download dei tweets.\n' "${account}"
	    printf '%s\n' "$(date)" >> "${dat_file_path}${account}.lock"
	else
	    printf '%s\n' "$(date)" >> "${dat_file_path}${account}.lock"
	    
	    exit 1;
	fi
	
	printf '/budus InsertCommandInQueueTimed(0) %d /budus pipe_script_silent %s %s\n' "${twitter_check:-1800}" "${0}" "${1}"
	exit 1;
    fi
    
    [ -f "${dat_file_path}${account}.lock" ] && \
	rm -f "${dat_file_path}${account}.lock"
    
    if [ ! -f "${dat_file_path}${account}.dat" ]; then
	tweet_record=$(head -n1 "${dat_file_path}${account}.db")
	cat "${dat_file_path}${account}.db" > "${dat_file_path}${account}.dat"
	
	print_tweet
    else
	for tweet_record in $(tac "${dat_file_path}${account}.db"); do
	    is_sended=$(grep -F "${tweet_record/*>/}" "${dat_file_path}${account}.dat")
	    
	    if [ "${is_sended}" == "" ]; then
		twitter_check=$((${twitter_check:-1800} / 4))
		print_tweet
		
		break;
	    fi
	done
    fi
done

printf '/budus InsertCommandInQueueTimed(0) %d /budus pipe_script_silent %s %s\n' "${twitter_check:-1800}" "${0}" "${1}"
